#include <ros/ros.h>
#include <image_transport/image_transport.h>
#include <cv_bridge/cv_bridge.h>
#include <sensor_msgs/image_encodings.h>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>
 
#include "opencv2/opencv.hpp"
#include <opencv2/core/core.hpp>
#include <opencv2/calib3d/calib3d.hpp>
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/contrib/contrib.hpp"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <string.h>
#include <cmath>
 
using namespace cv;
  
namespace enc = sensor_msgs::image_encodings;
  
static const char WINDOW[] = "Image Processed";
 
  
image_transport::Publisher pub1, pub2, pub3;
 
int a = 0;
 
Mat mapx1;
Mat mapy1;
Mat mapx2;
Mat mapy2;
 
Mat disp;
 
//OFLOwe
Point2f point;
bool addRemovePt = false;
 
static void onMouse( int event, int x, int y, int /*flags*/, void* /*param*/ )
{
    if( event == CV_EVENT_LBUTTONDOWN )
    {
        point = Point2f((float)x,(float)y);
        addRemovePt = true;
    }
}
 
 
//Disparity
void proracun_dispariteta(const Mat& g1, const Mat& g2, Mat &disp)
{
  
    StereoBM sbm;
    sbm.state->SADWindowSize = 9;
    sbm.state->numberOfDisparities = 112;
    sbm.state->preFilterSize = 5;
    sbm.state->preFilterCap = 61;
    sbm.state->minDisparity = -39;
    sbm.state->textureThreshold = 507;
    sbm.state->uniquenessRatio = 0;
    sbm.state->speckleWindowSize = 0;
    sbm.state->speckleRange = 8;
    sbm.state->disp12MaxDiff = 1;
     
    sbm(g1, g2, disp);
  
    normalize(disp, disp, 0, 255, CV_MINMAX, CV_8U);
}
  
void imageCallback(const sensor_msgs::ImageConstPtr& original_image)
{
    cv_bridge::CvImagePtr cv_ptr, cv_ptr1, cv_ptr2, cv_ptr3;
    try
    {
        cv_ptr = cv_bridge::toCvCopy(original_image, enc::RGB8);
        cv_ptr1 = cv_bridge::toCvCopy(original_image, enc::MONO8);
        cv_ptr2 = cv_bridge::toCvCopy(original_image, enc::MONO8);
        cv_ptr3 = cv_bridge::toCvCopy(original_image, enc::MONO8);
    }
    catch (cv_bridge::Exception& e)
    {
        ROS_ERROR("tutorialROSOpenCV::main.cpp::cv_bridge exception: %s", e.what());
        return;
    }
  
    cv::Mat channel[3];
    //Split B[0], G[1], R[2]
    cv::split(cv_ptr->image, channel);
    cv_ptr1->image = channel[0];
    cv_ptr2->image = channel[1];
    cv_ptr3->image = channel[2];
 
    Size imageSize;
    imageSize = cv_ptr1->image.size();
  
    //Rectification
    while(a==0)
    {
        FileStorage fs1("/home/student/ros/src/libhaloc/examples/intrinsics1.yml", FileStorage::READ);
        cv::Mat M1;
        fs1["M1"] >> M1;
        Mat D1;
        fs1["D1"] >> D1;
        Mat M2;
        fs1["M2"] >> M2;
        Mat D2;
        fs1["D2"] >> D2;
        fs1.release();
  
        FileStorage fs2("/home/student/ros/src/libhaloc/examples/extrinsics1.yml", FileStorage::READ);
        Mat R1;
        fs2["R1"] >> R1;
        Mat P1;
        fs2["P1"] >> P1;
        Mat R2;
        fs2["R2"] >> R2;
        Mat P2;
        fs2["P2"] >> P2;
        fs2.release();
 
        a=1;
 
        initUndistortRectifyMap(M1, D1, R1, P1, imageSize,
            CV_16SC2 , mapx1,  mapy1);
 
        initUndistortRectifyMap(M2, D2, R2, P2, imageSize,
            CV_16SC2 , mapx2,  mapy2);
    }
      
    remap(cv_ptr1->image, cv_ptr1->image, mapx1, mapy1, INTER_LINEAR);
    remap(cv_ptr2->image, cv_ptr2->image, mapx2, mapy2, INTER_LINEAR);
 
    resize(cv_ptr1->image, cv_ptr1->image, Size(), 0.2, 0.2, CV_INTER_AREA);
    resize(cv_ptr2->image, cv_ptr2->image, Size(), 0.2, 0.2, CV_INTER_AREA);
/*
    // Detecting corners
    cornerHarris( cv_ptr1->image, cv_ptr1->image, 2, 3, 0.04, BORDER_DEFAULT);
    cornerHarris( cv_ptr2->image, cv_ptr2->image, 2, 3, 0.04, BORDER_DEFAULT);
 
    // Normalizing
    normalize( cv_ptr1->image, cv_ptr1->image, 0, 255, NORM_MINMAX, CV_32FC1, Mat() );
    convertScaleAbs( cv_ptr1->image, cv_ptr1->image );
 
    normalize( cv_ptr2->image, cv_ptr2->image, 0, 255, NORM_MINMAX, CV_32FC1, Mat() );
    convertScaleAbs( cv_ptr2->image, cv_ptr2->image );
*/
    proracun_dispariteta(cv_ptr2->image , cv_ptr1->image, disp);
    imshow("disp", disp);
 
    cv::imshow("calib_right", cv_ptr1->image);
    cv::imshow("calib_middle", cv_ptr2->image);
    //cv::imshow("nesto3", cv_ptr3->image);
    cv::waitKey(3);
 
    if(a==2)
    {
        Mat image_of1 = imread("/home/student/ros/src/libhaloc/slike/frame01.bmp");
        Mat image_of2 = imread("/home/student/ros/src/libhaloc/slike/frame02.bmp");
 
        //Optical flow
        TermCriteria termcrit(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03);
        Size subPixWinSize(10,10), winSize(31,31);
 
        const int MAX_COUNT = 500;
        bool needToInit = false;
        bool nightMode = false;
 
        namedWindow( "LK Demo", 1 );
        setMouseCallback( "LK Demo", onMouse, 0 );
 
        Mat gray, prevGray, image;
        vector<Point2f> points[2];
 
         
            Mat frame;
            frame = cv_ptr1->image;
             
            frame.copyTo(image);
            cvtColor(image, gray, CV_BGR2GRAY);
 
            if( nightMode )
                image = Scalar::all(0);
 
            if( needToInit )
            {
                // automatic initialization
                goodFeaturesToTrack(gray, points[1], MAX_COUNT, 0.01, 10, Mat(), 3, 0, 0.04);
                cornerSubPix(gray, points[1], subPixWinSize, Size(-1,-1), termcrit);
                addRemovePt = false;
            }
            else if( !points[0].empty() )
            {
                vector<uchar> status;
                vector<float> err;
                prevGray = image_of1;
                calcOpticalFlowPyrLK(prevGray, gray, points[0], points[1], status, err, winSize,
                                     3, termcrit, 0, 0.001);
                size_t i, k;
                for( i = k = 0; i < points[1].size(); i++ )
                {
                    if( addRemovePt )
                    {
                        if( norm(point - points[1][i]) <= 5 )
                        {
                            addRemovePt = false;
                            continue;
                        }
                    }
 
                    if( !status[i] )
                        continue;
 
                    points[1][k++] = points[1][i];
                    circle( image, points[1][i], 3, Scalar(0,255,0), -1, 8);
                }
                points[1].resize(k);
            }
 
            if( addRemovePt && points[1].size() < (size_t)MAX_COUNT )
            {
                vector<Point2f> tmp;
                tmp.push_back(point);
                cornerSubPix( gray, tmp, winSize, cvSize(-1,-1), termcrit);
                points[1].push_back(tmp[0]);
                addRemovePt = false;
            }
 
            needToInit = false;
            imshow("LK Demo", image);
 
            char c = (char)waitKey(10);
         
 
            std::swap(points[1], points[0]);
            swap(prevGray, gray);
         
 
 
        a=1;
    }
 
    if(a==1)
    {
        vector<int> compression_params;
        compression_params.push_back(CV_IMWRITE_PNG_COMPRESSION);
        compression_params.push_back(9);
        imwrite("/home/student/ros/src/libhaloc/slike/frame01.bmp", cv_ptr1->image, compression_params);
        imwrite("/home/student/ros/src/libhaloc/slike/frame02.bmp", cv_ptr2->image, compression_params);
 
        a=2;
    }    
 
    pub1.publish(cv_ptr1->toImageMsg());
    pub2.publish(cv_ptr2->toImageMsg());
    pub3.publish(cv_ptr3->toImageMsg());
}
 
int main(int argc, char **argv)
{
    ros::init(argc, argv, "image_processor");
    ros::NodeHandle nh;
    image_transport::ImageTransport it(nh);
    cv::namedWindow(WINDOW, CV_WINDOW_AUTOSIZE);
    image_transport::Subscriber sub = it.subscribe("camera/image_raw", 1, imageCallback);
 
    ros::Publisher pub_info1 = nh.advertise<sensor_msgs::CameraInfo>("/stereo/right/camera_info", 1, imageCallback);
    ros::Publisher pub_info2 = nh.advertise<sensor_msgs::CameraInfo>("/stereo/middle/camera_info", 1, imageCallback);
    ros::Publisher pub_info3 = nh.advertise<sensor_msgs::CameraInfo>("/stereo/left/camera_info", 1, imageCallback);
    sensor_msgs::CameraInfo info_left;
    info_left.header.stamp = ros::Time::now();
    pub_info1.publish(info_left);
    pub_info2.publish(info_left);
    pub_info3.publish(info_left);
 
 
    cv::destroyWindow(WINDOW);
    pub1 = it.advertise("stereo/right/image_raw", 1);
    pub2 = it.advertise("stereo/left/image_raw", 1);
    pub3 = it.advertise("stereo/left1/image_raw", 1);
 
    ros::spin();
    ROS_INFO("tutorialROSOpenCV::main.cpp::No error.");
}