#include <ros/ros.h>
#include <image_transport/image_transport.h>
#include <cv_bridge/cv_bridge.h>
#include <sensor_msgs/image_encodings.h>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>

#include "opencv2/opencv.hpp"
#include <opencv2/core/core.hpp>
#include <opencv2/calib3d/calib3d.hpp>
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/contrib/contrib.hpp"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <string.h>
#include <cmath>

#include "opencv2/features2d/features2d.hpp"
#include "opencv2/nonfree/features2d.hpp"
#include "opencv2/nonfree/nonfree.hpp"

using namespace cv;
 
namespace enc = sensor_msgs::image_encodings;
 
static const char WINDOW[] = "Image Processed";

 
image_transport::Publisher pub1, pub2, pub3;

int a = 0;
int b = 0;
Mat mapx1;
Mat mapy1;
Mat mapx2;
Mat mapy2;

Mat disp;

//OFLOwe
Point2f point;
bool addRemovePt = false;

//SURF

Mat img_keypoints_1; Mat img_keypoints_2;
int minHessian = 400;
SurfFeatureDetector detector( minHessian );
std::vector<KeyPoint> keypoints_1, keypoints_2;
SurfDescriptorExtractor extractor;
Mat descriptors_1, descriptors_2;
FlannBasedMatcher matcher;
std::vector< DMatch > matches;
double max_dist = 0; double min_dist = 100;
Mat img_matches;



static void onMouse( int event, int x, int y, int /*flags*/, void* /*param*/ )
{
    if( event == CV_EVENT_LBUTTONDOWN )
    {
        point = Point2f((float)x,(float)y);
        addRemovePt = true;
    }
}


//Disparity
void proracun_dispariteta(const Mat& g1, const Mat& g2, Mat &disp)
{
 
    StereoBM sbm;
    sbm.state->SADWindowSize = 9;
    sbm.state->numberOfDisparities = 112;
    sbm.state->preFilterSize = 5;
    sbm.state->preFilterCap = 61;
    sbm.state->minDisparity = -39;
    sbm.state->textureThreshold = 507;
    sbm.state->uniquenessRatio = 0;
    sbm.state->speckleWindowSize = 0;
    sbm.state->speckleRange = 8;
    sbm.state->disp12MaxDiff = 1;
    
    sbm(g1, g2, disp);
 
    normalize(disp, disp, 0, 255, CV_MINMAX, CV_8U);
}
 
void imageCallback(const sensor_msgs::ImageConstPtr& original_image)
{
    cv_bridge::CvImagePtr cv_ptr, cv_ptr1, cv_ptr2, cv_ptr3;
    try
    {
        cv_ptr = cv_bridge::toCvCopy(original_image, enc::RGB8);
        cv_ptr1 = cv_bridge::toCvCopy(original_image, enc::MONO8);
        cv_ptr2 = cv_bridge::toCvCopy(original_image, enc::MONO8);
        cv_ptr3 = cv_bridge::toCvCopy(original_image, enc::MONO8);
    }
    catch (cv_bridge::Exception& e)
    {
        ROS_ERROR("tutorialROSOpenCV::main.cpp::cv_bridge exception: %s", e.what());
        return;
    }
 
    Mat channel[3];
    //Split B[0], G[1], R[2]
    split(cv_ptr->image, channel);
    cv_ptr2->image = channel[0];
    cv_ptr3->image = channel[1];
    cv_ptr1->image = channel[2];
    
    Size imageSize;
    imageSize = cv_ptr1->image.size();
 
    //Rectification
    while(a==0)
    {
        FileStorage fs1("/home/student/ros/src/libhaloc/examples/intrinsics1.yml", FileStorage::READ);
        Mat M1;
        fs1["M1"] >> M1;
        Mat D1;
        fs1["D1"] >> D1;
        Mat M2;
        fs1["M2"] >> M2;
        Mat D2;
        fs1["D2"] >> D2;
        fs1.release();
 
        FileStorage fs2("/home/student/ros/src/libhaloc/examples/extrinsics1.yml", FileStorage::READ);
        Mat R1;
        fs2["R1"] >> R1;
        Mat P1;
        fs2["P1"] >> P1;
        Mat R2;
        fs2["R2"] >> R2;
        Mat P2;
        fs2["P2"] >> P2;
        fs2.release();

        a=1;

        initUndistortRectifyMap(M1, D1, R1, P1, imageSize,
            CV_16SC2 , mapx1,  mapy1);

        initUndistortRectifyMap(M2, D2, R2, P2, imageSize,
            CV_16SC2 , mapx2,  mapy2);
    }
     
    remap(cv_ptr1->image, cv_ptr1->image, mapx1, mapy1, INTER_LINEAR);
    remap(cv_ptr2->image, cv_ptr2->image, mapx2, mapy2, INTER_LINEAR);

    resize(cv_ptr1->image, cv_ptr1->image, Size(), 0.5, 0.5, CV_INTER_AREA);
    resize(cv_ptr2->image, cv_ptr2->image, Size(), 0.5, 0.5, CV_INTER_AREA);
/*
    // Detecting corners
    cornerHarris( cv_ptr1->image, cv_ptr1->image, 2, 3, 0.04, BORDER_DEFAULT);
    cornerHarris( cv_ptr2->image, cv_ptr2->image, 2, 3, 0.04, BORDER_DEFAULT);

    // Normalizing
    normalize( cv_ptr1->image, cv_ptr1->image, 0, 255, NORM_MINMAX, CV_32FC1, Mat() );
    convertScaleAbs( cv_ptr1->image, cv_ptr1->image );

    normalize( cv_ptr2->image, cv_ptr2->image, 0, 255, NORM_MINMAX, CV_32FC1, Mat() );
    convertScaleAbs( cv_ptr2->image, cv_ptr2->image );
*/
    proracun_dispariteta(cv_ptr1->image , cv_ptr2->image, disp);
    imshow("disp", disp);
    hconcat(cv_ptr1->image, cv_ptr2->image, cv_ptr3->image);
    cv_ptr1->image=imread("/home/student/ros/src/libhaloc/slike/23.png");
    cv_ptr2->image=imread("/home/student/ros/src/libhaloc/slike/24.png");
    hconcat(cv_ptr1->image, cv_ptr2->image, cv_ptr3->image);
    //SURF
    //-- Step 1: Detect the keypoints using SURF Detector
    detector.detect( cv_ptr1->image, keypoints_1 );
    detector.detect( cv_ptr2->image, keypoints_2 );

    //-- Step 2: Calculate descriptors (feature vectors)
    extractor.compute( cv_ptr1->image, keypoints_1, descriptors_1 );
    extractor.compute( cv_ptr2->image, keypoints_2, descriptors_2 );

    //-- Step 3: Matching descriptor vectors using FLANN matcher
    matcher.match( descriptors_1, descriptors_2, matches );


    //-- Quick calculation of max and min distances between keypoints
    for( int i = 0; i < descriptors_1.rows; i++ )
    { double dist = matches[i].distance;
        if( dist < min_dist ) min_dist = dist;
        if( dist > max_dist ) max_dist = dist;
    }

    std::vector< DMatch > good_matches;

    for(size_t i = 0; i < matches.size(); i++)
    {
        Point2f point1 = keypoints_1[matches[i].queryIdx].pt;
        Point2f point2 = keypoints_2[matches[i].trainIdx].pt;
        // do something with the best points...
        if(abs(point1.y-point2.y)<5)
        {
            good_matches.push_back( matches[i]);
        }
    }
/*
    for( int i = 0; i < descriptors_1.rows; i++ )
    { if( matches[i].distance <= max(2*min_dist, 0.02) )
        { good_matches.push_back( matches[i]); }
    }
*/
    //-- Draw only "good" matches
    drawMatches( cv_ptr1->image, keypoints_1, cv_ptr2->image, keypoints_2,
                good_matches, img_matches, Scalar::all(-1), Scalar::all(-1),
                vector<char>(), DrawMatchesFlags::NOT_DRAW_SINGLE_POINTS );

    //-- Show detected matches
    imshow( "Good Matches", img_matches );
    vconcat(cv_ptr3->image, img_matches, cv_ptr3->image);
    //-- Draw keypoints
    drawKeypoints( cv_ptr1->image, keypoints_1, img_keypoints_1, Scalar::all(-1), DrawMatchesFlags::DEFAULT );
    drawKeypoints( cv_ptr2->image, keypoints_2, img_keypoints_2, Scalar::all(-1), DrawMatchesFlags::DEFAULT );

    //-- Show detected (drawn) keypoints
    imshow("Keypoints 1", img_keypoints_1 );
    imshow("Keypoints 2", img_keypoints_2 );


    imshow("calib_right", cv_ptr1->image);
    imshow("calib_center", cv_ptr2->image);
    //cv::imshow("nesto3", cv_ptr3->image);
    waitKey(3);

    if(a==2)
    {
        Mat image_of1 = imread("/home/student/ros/src/libhaloc/slike/frame01.bmp");
        Mat image_of2 = imread("/home/student/ros/src/libhaloc/slike/frame02.bmp");

        //Optical flow

        a=1;
    }

    if(a==1)
    {
        vector<int> compression_params;
        compression_params.push_back(CV_IMWRITE_PNG_COMPRESSION);
        compression_params.push_back(9);
        imwrite("/home/student/ros/src/libhaloc/slike/frame01.bmp", img_matches, compression_params);
        imwrite("/home/student/ros/src/libhaloc/slike/frame02.bmp", cv_ptr3->image, compression_params);

        a=2;
    }    

    pub1.publish(cv_ptr1->toImageMsg());
    pub2.publish(cv_ptr2->toImageMsg());
    pub3.publish(cv_ptr3->toImageMsg());
}

int main(int argc, char **argv)
{
    ros::init(argc, argv, "image_processor");
    ros::NodeHandle nh;
    image_transport::ImageTransport it(nh);
    cv::namedWindow(WINDOW, CV_WINDOW_AUTOSIZE);
    image_transport::Subscriber sub = it.subscribe("camera/image_raw", 1, imageCallback);

    ros::Publisher pub_info1 = nh.advertise<sensor_msgs::CameraInfo>("/stereo/right/camera_info2", 1, imageCallback);
    ros::Publisher pub_info2 = nh.advertise<sensor_msgs::CameraInfo>("/stereo/center/camera_info2", 1, imageCallback);
    ros::Publisher pub_info3 = nh.advertise<sensor_msgs::CameraInfo>("/stereo/left/camera_info2", 1, imageCallback);
    sensor_msgs::CameraInfo info_left;
    info_left.header.stamp = ros::Time::now();
    pub_info1.publish(info_left);
    pub_info2.publish(info_left);
    pub_info3.publish(info_left);


    destroyWindow(WINDOW);
    pub1 = it.advertise("camera/right/image_raw2", 1);
    pub2 = it.advertise("camera/center/image_raw2", 1);
    pub3 = it.advertise("camera/left/image_raw2", 1);

    ros::spin();
    ROS_INFO("tutorialROSOpenCV::main.cpp::No error.");
}